
'espacio de nombres que proporciona clases e interfaces que permiten la programacin multiproceso
Imports System.Threading
'para utilizar NotifyIcon
Imports System.Drawing

Public Class Form1
    Inherits System.Windows.Forms.Form

    'procedimiento Main para que la aplicacin arranque desde aqu
    <STAThread()>
    Public Shared Sub Main()
        'crear 2 hilos diferentes, cada hilo se enlaza con un mtodo para iniciar los formularios
        Dim hilo1 As New Thread(AddressOf Ventana1)
        Dim hilo2 As New Thread(AddressOf Ventana2)
        'despus se arrancan los 2 hilos
        hilo1.Start()
        'tiempo de espera
        System.Threading.Thread.Sleep(5000)
        hilo2.Start()
    End Sub

#Region " Cdigo generado por el Diseador de Windows Forms "

    Public Sub New()
        MyBase.New()

        'El Diseador de Windows Forms requiere esta llamada.
        InitializeComponent()

        'Agregar cualquier inicializacin despus de la llamada a InitializeComponent()

    End Sub

    'Form reemplaza a Dispose para limpiar la lista de componentes.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    Friend WithEvents BotonCerrar1 As Button
    Friend WithEvents LabelInfo1 As Label
    Friend WithEvents LabelInfo2 As Label
    Friend WithEvents BotonCerrar2 As Button
    Friend WithEvents NotifyIcon1 As NotifyIcon
    Friend WithEvents ToolTip1 As ToolTip

    'Requerido por el Diseador de Windows Forms
    Private components As System.ComponentModel.IContainer

    'NOTA: el Diseador de Windows Forms requiere el siguiente procedimiento
    'Puede modificarse utilizando el Diseador de Windows Forms. 
    'No lo modifique con el editor de cdigo.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.components = New System.ComponentModel.Container()
        Dim resources As System.ComponentModel.ComponentResourceManager = New System.ComponentModel.ComponentResourceManager(GetType(Form1))
        Me.BotonCerrar1 = New System.Windows.Forms.Button()
        Me.LabelInfo1 = New System.Windows.Forms.Label()
        Me.LabelInfo2 = New System.Windows.Forms.Label()
        Me.BotonCerrar2 = New System.Windows.Forms.Button()
        Me.NotifyIcon1 = New System.Windows.Forms.NotifyIcon(Me.components)
        Me.ToolTip1 = New System.Windows.Forms.ToolTip(Me.components)
        Me.SuspendLayout()
        '
        'BotonCerrar1
        '
        Me.BotonCerrar1.AutoSize = True
        Me.BotonCerrar1.FlatStyle = System.Windows.Forms.FlatStyle.Flat
        Me.BotonCerrar1.Font = New System.Drawing.Font("Verdana", 10.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.BotonCerrar1.Location = New System.Drawing.Point(106, 89)
        Me.BotonCerrar1.Name = "BotonCerrar1"
        Me.BotonCerrar1.Size = New System.Drawing.Size(80, 30)
        Me.BotonCerrar1.TabIndex = 1
        Me.BotonCerrar1.Text = "Cerrar"
        Me.BotonCerrar1.UseVisualStyleBackColor = True
        '
        'LabelInfo1
        '
        Me.LabelInfo1.AutoSize = True
        Me.LabelInfo1.Font = New System.Drawing.Font("Verdana", 8.0!)
        Me.LabelInfo1.Location = New System.Drawing.Point(69, 45)
        Me.LabelInfo1.Name = "LabelInfo1"
        Me.LabelInfo1.Size = New System.Drawing.Size(155, 28)
        Me.LabelInfo1.TabIndex = 0
        Me.LabelInfo1.Text = "Cerrar los 2 formularios" & Global.Microsoft.VisualBasic.ChrW(13) & Global.Microsoft.VisualBasic.ChrW(10) & "y salir de la aplicacin."
        Me.LabelInfo1.TextAlign = System.Drawing.ContentAlignment.MiddleCenter
        '
        'LabelInfo2
        '
        Me.LabelInfo2.AutoSize = True
        Me.LabelInfo2.Font = New System.Drawing.Font("Verdana", 8.0!)
        Me.LabelInfo2.Location = New System.Drawing.Point(67, 161)
        Me.LabelInfo2.Name = "LabelInfo2"
        Me.LabelInfo2.Size = New System.Drawing.Size(159, 28)
        Me.LabelInfo2.TabIndex = 2
        Me.LabelInfo2.Text = "Cerrar este formulario" & Global.Microsoft.VisualBasic.ChrW(13) & Global.Microsoft.VisualBasic.ChrW(10) & "sin salir de la aplicacin."
        Me.LabelInfo2.TextAlign = System.Drawing.ContentAlignment.MiddleCenter
        '
        'BotonCerrar2
        '
        Me.BotonCerrar2.AutoSize = True
        Me.BotonCerrar2.FlatStyle = System.Windows.Forms.FlatStyle.Flat
        Me.BotonCerrar2.Font = New System.Drawing.Font("Verdana", 10.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.BotonCerrar2.Location = New System.Drawing.Point(106, 206)
        Me.BotonCerrar2.Name = "BotonCerrar2"
        Me.BotonCerrar2.Size = New System.Drawing.Size(80, 30)
        Me.BotonCerrar2.TabIndex = 3
        Me.BotonCerrar2.Text = "Cerrar"
        Me.BotonCerrar2.UseVisualStyleBackColor = True
        '
        'NotifyIcon1
        '
        Me.NotifyIcon1.BalloonTipTitle = "Form1"
        Me.NotifyIcon1.Icon = CType(resources.GetObject("NotifyIcon1.Icon"), System.Drawing.Icon)
        Me.NotifyIcon1.Visible = True
        '
        'Form1
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(292, 270)
        Me.ControlBox = False
        Me.Controls.Add(Me.BotonCerrar2)
        Me.Controls.Add(Me.LabelInfo2)
        Me.Controls.Add(Me.LabelInfo1)
        Me.Controls.Add(Me.BotonCerrar1)
        Me.FormBorderStyle = System.Windows.Forms.FormBorderStyle.Fixed3D
        Me.Icon = CType(resources.GetObject("$this.Icon"), System.Drawing.Icon)
        Me.Name = "Form1"
        Me.StartPosition = System.Windows.Forms.FormStartPosition.Manual
        Me.Text = "Form1 - Hilo 1"
        Me.ResumeLayout(False)
        Me.PerformLayout()

    End Sub

#End Region

    'procedimiento que muestra el primer formulario
    Public Shared Sub Ventana1()
        Application.Run(New Form1)
    End Sub

    'procedimiento que muestra el segundo formulario
    Public Shared Sub Ventana2()
        Application.Run(New Form2)
    End Sub

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        'posicin del formulario
        Me.Top = 220
        Me.Left = 220

        'ocultar y mostrar el control para actualizar la informacin
        Me.NotifyIcon1.Visible = False
        Me.NotifyIcon1.Visible = True
        'definir el texto, admite referencias a variables
        Me.NotifyIcon1.BalloonTipText = "Form1 abierto"
        'milisegundos que tardar en ocultarse el globo
        Me.NotifyIcon1.ShowBalloonTip(2000)
    End Sub


    'Cerrar los 2 formularios y salir de la aplicacin
    Private Sub BotonCerrar_Click(sender As Object, e As EventArgs) Handles BotonCerrar1.Click
        Me.Close()
        Form2.Close()
        Application.Exit()
    End Sub

    'Cerrar este formulario sin salir de la aplicacin.
    Private Sub BotonCerrar2_Click(sender As Object, e As EventArgs) Handles BotonCerrar2.Click
        'ocultar y mostrar el control para actualizar la informacin
        Me.NotifyIcon1.Visible = False
        Me.NotifyIcon1.Visible = True
        'definir el texto, admite referencias a variables
        Me.NotifyIcon1.BalloonTipText = "Form1 cerrado"
        'milisegundos que tardar en ocultarse el globo
        Me.NotifyIcon1.ShowBalloonTip(2000)

        Me.Close()
    End Sub

    'mostrar la informacin al hacer clic en el icono del rea de notificacin
    Private Sub NotifyIcon1_Mouse(sender As Object, e As MouseEventArgs) Handles NotifyIcon1.MouseClick
        Me.NotifyIcon1.ShowBalloonTip(2000, "Info", "Form1 abierto", ToolTipIcon.Info)
    End Sub

End Class
